#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import os
import platform
import random
import time

import requests #pip3 install requests --user
from bs4 import BeautifulSoup #pip3 install bs4 --user

import pyautogui

formats = ['.jpg', '.gif', '.png']

headers_Get = {
    'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0',
    'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
    'Accept-Language': 'en-US,en;q=0.5',
    'Accept-Encoding': 'gzip, deflate',
    'DNT': '1',
    'Connection': 'keep-alive',
    'Upgrade-Insecure-Requests': '1'
}

def open_dict(dic) :
    flux = open(dic, 'r')
    L = [x[:-1] for x in flux.readlines()]
    flux.close()
    return(L)

def google_search(req) :
    liens = []
    s = requests.Session()
    q = '+'.join(req.split())
    url = 'https://www.google.com/search?q=' + q + '&ie=utf-8&oe=utf-8'
    r = s.get(url, headers=headers_Get)
    soup = BeautifulSoup(r.text, "html.parser")
    container = soup.find_all('div', class_='g')
    for result in container :
        try : title = result.h3.text
        except : continue
        #try : url = result.find('cite', class_='iUh30').text
        try : url = result.find('a')['href']
        except : continue
        if title.startswith('Index of /') and len(title) > 10 and url.endswith('/') : 
            liens.append(url)
        #print('\n', title, '\n', url)
    if len(liens) > 0 :
        return(liens)
    else :
        return(None)

def crawl(url) : #retourne une liste des urls .jpg .png .gif trouvés sur la page
    L = [] #la liste des urls en .jpg .png... trouvés sur le site
    try : r = requests.get(url)
    except : return(None)
    soup = BeautifulSoup(r.text, 'html.parser')
    try : 
        if soup.find('h1').text.startswith('Index of /') :
            # container[2] c'est le parent directory dans un indexof, container[3:] le reste des fichiers
            container = soup.find_all('tr')
            try :
                if container[2].find('a')['href'] != '/' : #au cas ou ca nous ferait retourner a l'index du site
                    parent_directory = container[2].find('a')['href']
                else :
                    parent_directory = None
                if len(container) > 3 : #au cas ou il n'y a aucun fichier sur la page
                    for result in container[3:] :
                        try : title = result.find('a').text
                        except : continue
                        try : result_url = result.find('a')['href']
                        except : continue
                        for f in formats :
                            if result_url.endswith(f) :
                                final_url = url + result_url
                                L.append(final_url)
                                print(final_url)
                    if len(L) > 0 :
                        return(L)
            except : pass
    except : pass
    return(None)

def firefox(url) :
    if platform.system() == 'Linux' : os.system('firefox')
    elif platform.system() == 'Darwin' : os.system('open -a /Applications/Firefox.app')
    time.sleep(2)
    pyautogui.press('enter')
    time.sleep(1.5)
    pyautogui.typewrite(url)
    pyautogui.press('enter')
    time.sleep(6)
    os.system('pkill firefox')

def main() :
    D = open_dict('mot.txt')
    while True :
        mot = random.choice(D)
        print('==============================\nNouvelle recherche pour:', mot)
        urls = google_search('indexof: ' + mot)
        if urls is None : 
            time.sleep(1) #une seconde de pause si on va deux fois de suite sur google
            continue #si on a aucun resultat on coupe ici (pour pas attendre les 5secondes)
        else :
            for url in urls :
                print('>', url)
                L = crawl(url) #la liste des urls trouvés sur la page
                if L is None :
                    time.sleep(0.5)
                    continue #si la liste est vide on passe a la suite
                image_url = random.choice(L)
                print('Next Image:', image_url)
                firefox(image_url)

if __name__ == '__main__':
    main()